> For the complete documentation index, see [llms.txt](https://developers.oxylabs.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.oxylabs.io/products/cn/web-scraper-api/mu-biao/dian-zi-shang-wu/city-market.md).

# City Market

了解如何开始抓取 City Market。

使用网页爬虫API，您可以抓取各种类型的 **City Market** 页面；以下是所有受支持的抓取器及其各自对应的 `来源` 值。响应以页面 HTML 的形式返回于 `内容`，在所述标准响应结构中描述的 [Realtime](/products/cn/web-scraper-api/integration-methods/realtime.md) 和 [Push-Pull](/products/cn/web-scraper-api/integration-methods/push-pull.md).

{% hint style="warning" %}
对于某些目标，我们的系统 **会强制进行 JavaScript 渲染** 即使您没有设置 `render`；这些请求会计为已渲染流量。强制渲染的目标列表以及如何关闭渲染，请参见 [在特定页面上强制渲染](/products/cn/web-scraper-api/features/js-rendering-and-browser-control.md#forcing-rendering-on-specific-pages).
{% endhint %}

<table><thead><tr><th width="250">来源</th><th>描述</th></tr></thead><tbody><tr><td><code>citymarket_search</code></td><td><a href="#search"><strong>搜索页面</strong></a> ，对应您选择的搜索词。</td></tr><tr><td><code>citymarket_product</code></td><td><a href="#product"><strong>商品页面</strong></a> 你选择的产品 ID 的。</td></tr></tbody></table>

任何其他 City Market 页面都可以通过传入其 `url` 即可，无需 `来源` 。

{% hint style="info" %}
除下列参数外，你还可以包含其他参数，例如 `user_agent_type`, `geo_location`, `render`，等等，以自定义您的抓取请求。了解更多 [这里](/products/cn/web-scraper-api/features.md).
{% endhint %}

## 搜索 <a href="#search" id="search"></a>

### 请求示例 <a href="#request-samples" id="request-samples"></a>

{% tabs %}
{% tab title="cURL" %}

```shell
curl 'https://realtime.oxylabs.io/v1/queries' \\
--user 'USERNAME:PASSWORD' \\
-H 'Content-Type: application/json' \\
-d '{
        "source": "citymarket_search",
        "query": "milk"
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint

# 构造负载。
payload = {
    'source': 'citymarket_search',
    'query': 'milk'
}

# 获取响应。
response = requests.request(
    'POST',
    'https://realtime.oxylabs.io/v1/queries',
    auth=('USERNAME', 'PASSWORD'),
    json=payload
)

# 不返回包含任务状态和结果 URL 的响应，而是返回
# 包含结果的 JSON 响应。
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "citymarket_search",
    query: "milk"
};

const options = {
    hostname: "realtime.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("Error:", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="HTTP" %}

```http
# 您提交的整个字符串都必须进行 URL 编码。

https://realtime.oxylabs.io/v1/queries?source=citymarket_search&query=milk&access_token=12345abcde
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    'source' => 'citymarket_search',
    'query' => 'milk'
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://realtime.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");

$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
    "bytes"
    "encoding/json"
    "fmt"
    "io/ioutil"
    "net/http"
)

func main() {
    const Username = "USERNAME"
    const Password = "PASSWORD"

    payload := map[string]interface{}{
        "source": "citymarket_search",
        "query": "milk",
    }

    jsonValue, _ := json.Marshal(payload)

    client := &http.Client{}
    request, _ := http.NewRequest("POST",
        "https://realtime.oxylabs.io/v1/queries",
        bytes.NewBuffer(jsonValue),
    )

    request.SetBasicAuth(Username, Password)
    response, _ := client.Do(request)

    responseText, _ := ioutil.ReadAll(response.Body)
    fmt.Println(string(responseText))
}
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new {
                source = "citymarket_search",
                query = "milk"
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://realtime.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.ASCIIEncoding.UTF8.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONObject;
import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "citymarket_search");
        jsonObject.put("query", "milk");

        Authenticator authenticator = (route, response) -> {
            String credential = Credentials.basic(USERNAME, PASSWORD);
            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .readTimeout(180, TimeUnit.SECONDS)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://realtime.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("Error: " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "citymarket_search",
    "query": "milk"
}
```

{% endtab %}
{% endtabs %}

### 请求参数值 <a href="#request-parameter-values" id="request-parameter-values"></a>

<table><thead><tr><th width="180">参数</th><th>描述</th><th width="160">默认值</th></tr></thead><tbody><tr><td><mark style="background-color:green;"><strong><code>来源</code></strong></mark></td><td>设置抓取器。</td><td><code>citymarket_search</code></td></tr><tr><td><mark style="background-color:green;"><strong><code>query</code></strong></mark></td><td>用于搜索产品的关键词或短语。</td><td>-</td></tr><tr><td><code>store_id</code>, <code>delivery_zip</code>, <code>fulfillment_type</code>, <code>price_range</code>, <code>brand</code></td><td>可选的本地化和筛选参数，见 <a href="#localization-and-filtering">本地化和筛选</a>.</td><td>-</td></tr></tbody></table>

&#x20;   \- 必填参数

## 产品 <a href="#product" id="product"></a>

### 请求示例 <a href="#request-samples" id="request-samples"></a>

{% tabs %}
{% tab title="cURL" %}

```shell
curl 'https://realtime.oxylabs.io/v1/queries' \\
--user 'USERNAME:PASSWORD' \\
-H 'Content-Type: application/json' \\
-d '{
        "source": "citymarket_product",
        "product_id": "0001111016338"
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint

# 构造负载。
payload = {
    'source': 'citymarket_product',
    'product_id': '0001111016338'
}

# 获取响应。
response = requests.request(
    'POST',
    'https://realtime.oxylabs.io/v1/queries',
    auth=('USERNAME', 'PASSWORD'),
    json=payload
)

# 不返回包含任务状态和结果 URL 的响应，而是返回
# 包含结果的 JSON 响应。
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "citymarket_product",
    product_id: "0001111016338"
};

const options = {
    hostname: "realtime.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("Error:", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="HTTP" %}

```http
# 您提交的整个字符串都必须进行 URL 编码。

https://realtime.oxylabs.io/v1/queries?source=citymarket_product&product_id=0001111016338&access_token=12345abcde
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    'source' => 'citymarket_product',
    'product_id' => '0001111016338'
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://realtime.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");

$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
    "bytes"
    "encoding/json"
    "fmt"
    "io/ioutil"
    "net/http"
)

func main() {
    const Username = "USERNAME"
    const Password = "PASSWORD"

    payload := map[string]interface{}{
        "source": "citymarket_product",
        "product_id": "0001111016338",
    }

    jsonValue, _ := json.Marshal(payload)

    client := &http.Client{}
    request, _ := http.NewRequest("POST",
        "https://realtime.oxylabs.io/v1/queries",
        bytes.NewBuffer(jsonValue),
    )

    request.SetBasicAuth(Username, Password)
    response, _ := client.Do(request)

    responseText, _ := ioutil.ReadAll(response.Body)
    fmt.Println(string(responseText))
}
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new {
                source = "citymarket_product",
                product_id = "0001111016338"
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://realtime.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.ASCIIEncoding.UTF8.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONObject;
import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "citymarket_product");
        jsonObject.put("product_id", "0001111016338");

        Authenticator authenticator = (route, response) -> {
            String credential = Credentials.basic(USERNAME, PASSWORD);
            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .readTimeout(180, TimeUnit.SECONDS)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://realtime.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("Error: " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "citymarket_product",
    "product_id": "0001111016338"
}
```

{% endtab %}
{% endtabs %}

### 请求参数值 <a href="#request-parameter-values" id="request-parameter-values"></a>

<table><thead><tr><th width="167.1171875">参数</th><th width="409.05078125">描述</th><th width="181.80859375">默认值</th></tr></thead><tbody><tr><td><mark style="background-color:green;"><strong><code>来源</code></strong></mark></td><td>设置抓取器。</td><td><code>citymarket_product</code></td></tr><tr><td><mark style="background-color:green;"><strong><code>product_id</code></strong></mark></td><td>13 位产品 ID，位于产品页面 URL 末尾，例如 <code>citymarket.com/p/kroger-carbmaster-original-lactose-free-skim-milk/</code><strong><code>0001111016338</code></strong>.</td><td>-</td></tr><tr><td><code>store_id</code>, <code>delivery_zip</code>, <code>fulfillment_type</code></td><td>可选的本地化参数，见 <a href="#localization-and-filtering">本地化和筛选</a>.</td><td>-</td></tr></tbody></table>

&#x20;   \- 必填参数

## 本地化和筛选 <a href="#localization-and-filtering" id="localization-and-filtering"></a>

City Market 会显示所选门店或配送区域的搜索结果和产品可用性。如果未设置以下参数，网站会回退到其自行选择的门店。

<table><thead><tr><th width="134.00390625">参数</th><th width="116.96875">适用于</th><th width="296.34765625">描述</th><th width="212.34765625">默认</th></tr></thead><tbody><tr><td><code>store_id</code></td><td><code>citymarket_search</code>, <code>citymarket_product</code></td><td>选择门店。ID 由 citymarket.com 上门店页面 URL 中的分区编号和门店编号拼接而成： <code>…/stores/grocery/co/woodland-park/gold-hill-woodland-park/620/00431</code> → <code>62000431</code>。在……时必需 <code>fulfillment_type</code> 为 <code>pickup</code> 或 <code>in_store</code>.</td><td>-</td></tr><tr><td><code>delivery_zip</code></td><td><code>citymarket_search</code>, <code>citymarket_product</code></td><td>配送区域的 ZIP 代码，例如 <code>81601</code>。在……时必需 <code>fulfillment_type</code> 为 <code>delivery</code>.</td><td>-</td></tr><tr><td><code>fulfillment_type</code></td><td><code>citymarket_search</code>, <code>citymarket_product</code></td><td>履约方式。可用值： <code>pickup</code>, <code>delivery</code>, <code>in_store</code>. <code>pickup</code> 和 <code>in_store</code> 需要 <code>store_id</code>; <code>delivery</code> 需要 <code>delivery_zip</code>.</td><td><code>in_store</code> 与 <code>store_id</code> 单独， <code>delivery</code> 与 <code>delivery_zip</code> 单独</td></tr><tr><td><code>price_range</code></td><td><code>citymarket_search</code></td><td>价格筛选器，格式为 <code>min_price-max_price</code> 保留两位小数，例如 <code>2.00-5.00</code>.</td><td>-</td></tr><tr><td><code>brand</code></td><td><code>citymarket_search</code></td><td>将结果筛选为单一品牌，例如 <code>Fairlife</code>.</td><td>-</td></tr></tbody></table>

如果 `fulfillment_type` 在未设置其所需参数的情况下设置时，结果会返回 `status_code` 400。一个 `store_id` 位于 City Market 之外的门店，或一个 `delivery_zip` 位于其配送区域之外时，返回 `status_code` 613.

```json
{
    "source": "citymarket_search",
    "query": "milk",
    "store_id": "62000431",
    "fulfillment_type": "pickup",
    "brand": "Fairlife"
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developers.oxylabs.io/products/cn/web-scraper-api/mu-biao/dian-zi-shang-wu/city-market.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
